import * as React from 'react';
import * as ReactDOM from 'react-dom';
import ListView from '../../lib/list-view';
import Api from '../webapi/index';

class Demo extends React.Component<any, any> {
  constructor(props, state) {
    super(props, state);
  }

  public state = {
    src: '',
    reloadId: 0
  }

  public componentDidMount() {
    // setTimeout(() => {
    //   this.setState({
    //     reloadId: 1
    //   });
    // }, 2000);
  }
  public render() {
    const params = {
      api: '/wechat/brochure/getbuildinginfolist',
      params: {
        cityName: '重庆市',
        page: 0,
        showNumber: 5
      },
      isCache: false
    };
    return (
      <ListView
        request={Api.send}
        params={params}
        dataKey={['result']}
        pageKey="page"
        pageSizeKey="showNumber"
        rowRender={(data, i) => <div className="test" key={i}>{i}</div>}
        emptyView={<div>空视图</div>}
        failView={<div>加载失败视图</div>}
        timeoutView={<div>超时的视图</div>}
        loadingView={<div>加载中的视图</div>}
        reloadId={this.state.reloadId}
        filter={(data) => data.buildingInfoId > 146}
        //value={this.state.accessTime}
        // visible={this.state.accessTimeShow}
        //onOk={(values) => this.setState({ accessTime: values.value })}
      />
    );
  }
}

ReactDOM.render(<Demo />, document.getElementById('root'));