interface TspComponentCalendarProps {
  className?: string;
  /**
   * 组件宽度
   */
  width?: number;
  /**
   * 组件高度
   */
  height?: number;
  /**
   * 滑动完成后触发的事件
   */
  afterChange?: (indexs: TspComponentSliderAfterChangeReturn, values: number[]) => void;
  /**
   * 点击日历
   */
  onClick?: (values: number[]) => void;
  /**
   * 左箭头
   */
  leftArrow?: any;
  /**
   * 右箭头
   */
  rightArrow?: any;
  /**
   * 默认年份
   */
  year?: number;
  /**
   * 默认月份
   */
  month?: number;
  /**
   * 默认哪天
   */
  day?: number;
  /**
   * 需要加深颜色的日期
   */
  darken?: string[];
  /**
   * 刷新ID
   */
  refreshId?: number;
}

interface TspComponentCalendarGetCalendarRenderDataReturn {
  /**
   * 上一个月显示的天数
   */
  prevMonthDisplayDays: number[];
  /**
   * 当月显示的天数
   */
  currentMonthDays: number[];
  /**
   * 下一个月显示的天数
   */
  nextMonthDays: number[];
  /**
   * 日历表
   */
  table: number[];
}