interface TspComponentDatePickerProps extends TspComponentPickerCore {
  className?: string;
  /**
   * 开始的日期
   */
  startDate?: string[];
  /**
   * 结束的日期
   */
  endDate?: string[];
  /**
   * 月份起始时间是否和startDate相同
   */
  enableStartDate?: boolean;
  /**
   * 月份结束时间是否和endDate相同
   */
  enableEndDate?: boolean;
  /**
   * 日期模式
   */
  mode?: TspComponentDatePickerModel;
  /**
   * 更新ID
   */
  updateId?: number;
  // value属性中年份是数字其他是字符串
}

type TspComponentDatePickerModel = 'yy' | 'yyMM' | 'yyMMdd' | 'yyMMddHH' | 'yyMMddHHmm' | 'HHmm';

interface TspComponentDatePickerModelReturn {
  /**
   * 年
   */
  y: string[];
  /**
   * 月
   */
  M: string[];
  /**
   * 日
   */
  d: string[];
  /**
   * 小时
   */
  H: string[];
  /**
   * 分
   */
  m: string[];
}