type TspComponentEventTrackingListenParams = {
  key: string;
  actionName: string;
}[]

interface TspComponentEventTrackingLog {
  id: string;
  value: object;
}

interface TspComponentEventTrackingTriggerParams {
  id?: string;
  value?: object;
  /** 行为名称 */
  actionName?: string;
}

interface TspComponentEventTrackingListenCommon {
  /**
   * 楼盘id
   */
  buildingProjectId?: string;
  /**
   * 户型id
   */
  houseId?: string;
  terminal_id: number;
}

interface TspComponentEventTrackingCurrentLogData {
  id: string;
  /**
   * 楼盘id
   */
  buildingProjectId: string;
  /**
   * 户型id
   */
  houseId: string;
  /**
   * 一级模块
   */
  // topModule: string;
  /**
   * 次级模块
   */
  // secondaryModule: string;
  /**
   * 动作名称
   */
  actionName: string;
  /**
   * 行为详细描述
   */
  behaviorName?: string;
  /**
   * 主类型
   */
  mainType?: string;
  /**
   * 子类型
   */
  subType?: string;
  /**
   * 创建时间
   */
  createTime: string;
  /**
   * 详情数据
   */
  detailedData: string;
  /**
   * 上级页面
   */
  parentPage: string;
  /**
   * 停留时间
   */
  stopSeconds: number;
}

interface TspComponentEventTrackingCurrentLog {
  actionName: string;
  buildingProjectId: string;
  houseId: string;
  time: number;
  data: TspComponentEventTrackingCurrentLogData[];
}