declare enum productCode {
  /**
   * 微信端电子楼书 
   */
  LouShuWeiXin = 1,
  /**
   * 置业顾问 
   */
  ZhiYeGuWen = 2,
  /**
   * 销售经理 
   */
  XiaoShouJingLi = 3
}

declare enum ExceptionErrorType {
  /**
   * js错误 
   */
  javascript = 1,
  /**
   * 接口错误 
   */
  interfaceFail = 2,
  /**
   * 接口超时 
   */
  interfaceTimeout = 3,
  /**
   * 图片失效
   */
  imageInvalid = 4,
  /**
   * 图片超时
   */
  imageTimeout = 5,
  
}

type ExceptionProductCode = productCode;

// interface ExceptionParams {
//   /**
//    * 服务器地址
//    */
//   host?: string;
//   /**
//    * api地址
//    */
//   api?: string;
//   /**
//    * 产品编码
//    */
//   productCode?: productCode;
// }

interface ExceptionSendParams {
  col?: number;
  errorType: ExceptionErrorType;
  line?: number;
  content: string;
  details?: string;
  productCode?: productCode;
  url?: string;
}

interface ExceptionData extends ExceptionSendParams, ExceptionUserInfo {
  userAgent: string;
  network: string;
  currentPage: string;
  version: string;
}

interface ExceptionUserInfo {
  lat: string;
  lng: string;
  account: string;
  openId: string;
}