import { regexp } from '../util/validate';
var FormCore = (function () {
    function FormCore(params) {
        this.elem = params.elem;
        if (params.required) {
            this.setRequired(params.required);
        }
        if (params.patternType || params.pattern) {
            this.setPattern({
                pattern: params.pattern,
                patternType: params.patternType,
                patternTrigger: params.patternTrigger,
                patternMsg: params.patternMsg,
            });
        }
        this.setValue(params.defaultValue);
    }
    FormCore.prototype.setRequired = function (required) {
        this.elem.dataset.required = 'true';
        this.elem.dataset.requiredMsg = required;
    };
    FormCore.prototype.setPattern = function (params) {
        var pattern = params.pattern, patternType = params.patternType, patternTrigger = params.patternTrigger, patternMsg = params.patternMsg;
        if (pattern) {
            this.elem.dataset.pattern = pattern.toString();
        }
        else {
            this.elem.dataset.pattern = regexp[patternType].toString();
            this.elem.dataset.patternType = patternType;
        }
        if (patternTrigger) {
            this.elem.dataset.patternTrigger = patternTrigger.toString();
        }
        if (patternMsg) {
            this.elem.dataset.patternMsg = patternMsg;
        }
    };
    FormCore.prototype.setValue = function (value) {
        this.elem.dataset.value = value ? value.toString() : '';
    };
    return FormCore;
}());
export default FormCore;
