import * as React from 'react';
import ReactCSSTransitionGroup from 'react/lib/ReactCSSTransitionGroup';
import classNames from 'classnames';
import Framework from './index';

const Container = (props) => {
  return (
    <ReactCSSTransitionGroup
      transitionName={classNames({
        transitionPush: Framework.global.urlAction === 'PUSH' || Framework.global.urlAction === 'REPLACE',
        transitionPop: Framework.global.urlAction === 'POP'
      })}
      component="div"
      transitionEnterTimeout={300}
      transitionLeaveTimeout={250}
    >
      {React.cloneElement(props.children, { key: props.location.pathname, props })}
    </ReactCSSTransitionGroup>
  );
};

export default Container;