import Exception from '../exception';

class Global {
  /**
   * 是否登录
   */
  public isLogin: boolean;
  /**
   * 用户帐户
   */
  public get account(): string {
    return localStorage.getItem('account') ? localStorage.getItem('account') : '';
  }
  public set account(account: string) {
    Exception.account = account;
    localStorage.setItem('account', account);
  }
  /**
   * openid
   */
  public get openId(): string {
    return localStorage.getItem('openId') ? localStorage.getItem('openId') : '';
  }
  public set openId(openId: string) {
    Exception.openId = openId;
    localStorage.setItem('openId', openId);
  }
  /**
   * webvview打开的链接
   */
  public get webviewSrc(): string {
    return localStorage.getItem('webviewSrc') ? localStorage.getItem('webviewSrc') : '';
  }
  public set webviewSrc(url: string) {
    localStorage.setItem('webviewSrc', url);
  }
  /**
   * 纬度
   */
  public lat: string;
  /**
   * 经度
   */
  public lng: string;
  /**
   * 当前路由
   */
  public routerPath: string;
  /**
   * 路由历史记录
   */
  public routerHistory: string[] = [];
  /**
   * url动作， PUSH POP REPLACE
   */
  public urlAction: string;
  /**
   * 网络环境
   */
  public network: string;
}

export default Global;