import Exception from '../exception';
import Promise from 'promise-polyfill';
import WebApi from '../ajax/webapi';
import View from '../view';
import ListView from '../list-view';
import EventTracking from '../event-tracking';
export default function init(options, request) {
    View.defaultProps.request = request.send;
    ListView.defaultProps.request = request.send;
    WebApi.response = options.request.response;
    WebApi.defaultParams = options.request.defaultParams;
    if (!window['Promise']) {
        window['Promise'] = Promise;
    }
    if (options.component.Exception) {
        if (options.component.Exception.apiname) {
            Exception.apiname = options.component.Exception.apiname;
        }
        Exception.productCode = 1;
        Exception.version = options.config.version;
        Exception.webapi = new WebApi('https://fed.summersky.cn', undefined);
        Exception.listen();
    }
    if (options.component.EventTracking) {
        EventTracking.request = request.send;
        EventTracking.api = options.component.EventTracking.api;
        EventTracking.host = options.component.EventTracking.host;
        EventTracking.onUnload();
    }
}
