/// <reference path="./definition.d.ts" />

import * as React from 'react';
import Hammer from 'react-hammerjs';
import classNames from 'classnames';

const Icon = (props: TspComponentIconProps) => {
  const svg = (
    <svg className={classNames({
      [props.className]: props.className
    })}>
      <use xlinkHref={props.src} />
    </svg>
  );
  let elem;
  if (props.onClick) {
    elem = <Hammer onTap={props.onClick}>{svg}</Hammer>;
  } else {
    elem = svg;
  }
  return elem;
};

export default Icon;