interface TspComponentInputProps extends TspComponentFormCore {
  id: string;
  /**
   * 类名
   */
  className?: string;
  /**
   * input type
   */
  type?: string;
  /**
   * input placeholder
   */
  placeholder?: string;
  /**
   * 默认值
   */
  defaultValue: string | number;
  /**
   * input maxLength
   */
  maxLength?: number;
  /**
   * input disabled
   * input中disabled与readonly的区别
   * http://blog.it985.com/7611.html
   */
  disabled?: boolean;
  /**
   * input readOnly
   * input中disabled与readonly的区别
   * http://blog.it985.com/7611.html
   */
  readOnly?: boolean;
  /**
   * input change
   */
  onChange?: (value: string, e: any) => void;
  /**
   * input blur
   */
  onBlur?: (value: string | number, e: any) => void;
  /**
   * 是否过滤emoji
   */
  emoji?: boolean;
}

interface TspComponentInputState {
  value: string | number;
}