
/**
 * 给element设置transform style
 */
export function setTranslate(elem: HTMLElement, x: number, y: number): void {
  elem.style.webkitTransform = `translate(${x}px, ${y}px) translateZ(0)`;
}

/**
 * 获取translate样式文本 
 */
export function getTranslateText(x: number | string, y: number | string): string {
   return `-webkit-transform:translate(${x}, ${y})  translateZ(0);transform:translate(${x}, ${y})  translateZ(0);`;
}

// /**
//  * requestAnimationFrame兼容
//  */
export function requestAnimationFrame(): any {
  return (function(): any {
    return  window.requestAnimationFrame       ||
            window.webkitRequestAnimationFrame ||
            function(callback: Function): void {
              window.setTimeout(callback, 1000 / 60);
            };
  })();
}